;(function($) {
    'use strict'

    /**
		We inject the config as a variable signatuConfig into this script
	 */

    $(window).load(function() {
        var version = signatuConfig.version
        console.log('Running Signatu plugin version: ', version)
        ;(function(window, document) {
            if (window.Signatu) {
                return console.warn('Signatu loader is already included')
            }
            var m = ['init']
            // eslint-disable-next-line no-underscore-dangle
            window.Signatu = { _c: [] }
            // eslint-disable-next-line no-underscore-dangle
            m.forEach(
                ms =>
                    (window.Signatu[ms] = (...args) => {
                        window.Signatu._c.push([ms, args])
                    })
            )
            var elt = document.createElement('script')
            elt.type = 'text/javascript'
            elt.async = true
            elt.src = signatuConfig.baseUrl + '/shim.js'
            var before = document.getElementsByTagName('script')[0]
            before.parentNode.insertBefore(elt, before)
        })(window, document)

        console.log('Signatu started with config: ', signatuConfig, window.Signatu)

        var config = {
            origin: signatuConfig.origin,
            app: signatuConfig.app,
            version,
            baseUrl: signatuConfig.baseUrl,
            language: signatuConfig.language,
            subject: signatuConfig.subject,
            endPoints: signatuConfig.endPoints,
            /** We will proxy the requests to the WP site and decorate with accessToken there */
            accessToken: 'N/A',
            headers: {
                'X-WP-Nonce': signatuConfig.nonce,
            },
            options: {
                groupId: signatuConfig.groupId,
                position: signatuConfig.position,
                variant: signatuConfig.variant,
                privacyPolicyUrl: signatuConfig.privacyPolicyUrl,
            },
        }

        /** Validate the configuration */
        if (!(config.options.groupId && config.baseUrl)) {
            console.warn(
                `Signatu Cookie Banner is not configured correctly. In Wordpress admin, go to Settings->Signatu to configure the plugin.`
            )
            return
        }

        window.Signatu.init(config)
    })
})(jQuery)
